/*******************
VARIABLES
*******************/
var creativeId = "Banner"; 
var creativeVersion = "1.1.0";
var lastModified = "2018-05-07";
var lastUploaded = "2018-05-07";

var templateVersion = "2.0.24";
var dimensions;
var scrollPos = {
	x: 0,
	y: 0
};

var bannerDiv;
var bannerRollover;
var contentLabel;
var expandButton;
var sdkData;
var adId, rnd, uid;
var enableBannerRollover = true;

/*******************
INITIALIZATION
*******************/
function checkIfAdKitReady(event) {
	try {
		if (window.localPreview) {
			window.initializeLocalPreview(); //in localPreview.js
			initializeCreative();
			return;
		}
	}
	catch (e) {}

	adkit.onReady(initializeCreative);
}

function initializeCreative(event) {
	

	// so messaging can work in safe frames we need to bind the events that are present in the event manager.
	EBG.pm.bind("sendCreativeId", function () {
		eventManager.apply(this, arguments);
	}, this);
	EBG.pm.bind("eventCallback", function () {
		eventManager.apply(this, arguments);
	}, this);


	//Workaround (from QB6573) for Async EB Load where Modernizr isn't properly initialized
	typeof Modernizr == "object" && (Modernizr.touch = Modernizr.touch || "ontouchstart" in window);

	initializeGlobalVariables();
	window.registerInteraction = function() {}; //overwrite rI function because it will never actually be called
	addEventListeners();
	displayDimensions();
	setBanner();
	setCreativeVersion();
}

function initializeGlobalVariables() {
	adId = EB._adConfig.adId;
	rnd = EB._adConfig.rnd;
	uid = EB._adConfig.uid;

	bannerDiv = document.getElementById("banner");
	bannerRollover = document.getElementById("banner-rollover");
	contentLabel = document.getElementById("content-label");
	expandButton = document.getElementById("expand-button");
	//dimensions = document.getElementById("dimensions"); //for testing only, show the dimensions and scrollpos of the parent
	sdkData = EB.getSDKData();
}

function addEventListeners() {
	if (!EB.API.os.mobile) {
		bannerDiv.addEventListener("mouseover", showBannerRollover);
		bannerDiv.addEventListener("mouseout", hideBannerRollover);
	}
	expandButton.addEventListener("click", handleExpandButtonClick);
	bannerRollover.addEventListener("click", handleExpandButtonClick);

	window.addEventListener("resize", setBanner);
}

function setBanner() {
	// var viewport = EB.API.getViewPortMetrics();
	// var bannerBorderWidth = parseInt(getStyle(bannerDiv, "border-top-width") || getStyle(bannerDiv, "border-width"));
	// EB.API.setStyle(bannerDiv, {
	// 	width: EBG.px(viewport.width - (bannerBorderWidth * 2)),
	// 	height: EBG.px(viewport.height - (bannerBorderWidth * 2))
	// });

	if (EB.API.os.mobile) {
		EB.API.setStyle(expandButton, {
			display: "block"
		});
	}
	// else {
	// 	var bannerRolloverBorderWidth = parseInt(getStyle(bannerRollover, "border-top-width") || getStyle(bannerDiv, "border-width"));
	// 	EB.API.setStyle(bannerRollover, {
	// 		width: EBG.px(viewport.width - (bannerRolloverBorderWidth * 2)),
	// 		height: EBG.px(viewport.height - (bannerRolloverBorderWidth * 2))
	// 	});
	// 	var bannerRolloverLabel = bannerRollover.querySelector("label");
	// 	if (bannerRolloverLabel) {
	// 		EB.API.setStyle(bannerRolloverLabel, {
	// 			top: EBG.px(Math.floor((parseInt(getStyle(bannerRollover, "height"))- (bannerRolloverBorderWidth * 2)) / 2))
	// 		});
	// 	}
	// }
	EB.API.setStyle(bannerDiv, {
		display: "block"
	});
}

function registerInteraction() {
	//Register your automatic and user interactions here and the platform will parse them on workspace upload. This function will not be called.
	//Example: 'Left_Gutter_Viewed'
}

function getStyle(elem, styleName) {
	if (elem.currentStyle) {
		return elem.currentStyle[styleName];
	}
	else if (window.getComputedStyle) {
		return document.defaultView.getComputedStyle(elem, null).getPropertyValue(styleName);
	}
	else {
		return elem.style[styleName];
	}
}

/*******************
EVENT HANDLERS
*******************/
function handleExpandButtonClick() {
	enableBannerRollover = false;
	hideBannerRollover();
	EB.expand();
	setTimeout(function() {
		enableBannerRollover = true;
	}, 500);
}

/*
function handleCloseButtonClick() {
	EB.collapse();
}
*/

/*******************
UTILITIES
*******************/
function expand() {
	handleExpandButtonClick();
}

/*
function collapse() {
	handleCloseButtonClick();
}
*/

function onPageScroll(event) {
	scrollPos.x = event.scrollXPercent;
	scrollPos.y = event.scrollYPercent;
	displayDimensions();
}

function showBannerRollover() {
	if (enableBannerRollover) {
		EB.API.setStyle(bannerRollover, {
			display: "block"
		});
	}
}

function hideBannerRollover() {
	EB.API.setStyle(bannerRollover, {
		display: "none"
	});	
}


/*******************
UTILITIES
*******************/

function displayDimensions() {
	if(dimensions) {
		var iw = window.innerWidth,
			ih = window.innerHeight,
			sx = scrollPos.x,
			sy = scrollPos.y;
		var str = "<br>Viewport: " + iw + "x" + ih + " | <span style='display:block'>Scroll (X: " + sx + "%; Y: " + sy + "%)</span>";
		dimensions.innerHTML = str;
	}
}

function setCreativeVersion() {
	sendMessage("setCreativeVersion", {
		creativeId: creativeId,
		creativeVersion: creativeVersion,
		creativeLastModified: lastModified,
		uid: uid
	});
}

/*********************************
HTML5 Event System - Do Not Modify
*********************************/
var listenerQueue;
var creativeIFrameId;

function sendMessage(type, data) {

	//note: the message type we're sending is also the name of the function inside
	//		the custom script's messageHandlers object, so the case must match.

	if(!data.type) data.type = type;
	EB._sendMessage(type, data);
}

function addCustomScriptEventListener(eventName, callback, interAd) {
	listenerQueue = listenerQueue || {};
	var data = {
		uid: uid,
		listenerId: Math.ceil(Math.random() * 1000000000),
		eventName: eventName,
		interAd: !!(interAd),
		creativeIFrameId: creativeIFrameId
	};
	sendMessage("addCustomScriptEventListener", data);
	data.callback = callback;
	listenerQueue[data.listenerId] = data;
	return data.listenerId;
}

function dispatchCustomScriptEvent(eventName, params) {
	params = params || {};
	params.uid = uid;
	params.eventName = eventName;
	params.creativeIFrameId = creativeIFrameId;
	sendMessage("dispatchCustomScriptEvent", params);
}

function removeCustomScriptEventListener(listenerId) {
	var params = {
		uid: uid,
		listenerId: listenerId,
		creativeIFrameId: creativeIFrameId
	};

	sendMessage("removeCustomScriptEventListener", params);
	if(listenerQueue[listenerId])
		delete listenerQueue[listenerId];
}

function eventManager(event) {

	var msg;
	if(typeof event == "object" && event.data) {
		msg = JSON.parse(event.data);

	}
	else {
		// this is safe frame.
		msg = {
			type: event.type,
			data: event
		};
	}
	if(msg.type && msg.data && (!uid || (msg.data.uid && msg.data.uid == uid))) {
		switch(msg.type) {
		case "sendCreativeId":
			creativeIFrameId = msg.data.creativeIFrameId;
			addCustomScriptEventListener('pageScroll', onPageScroll);
			sendMessage("dispatchScrollPos", {
				uid: uid
			});
			if(creativeContainerReady)
				creativeContainerReady();
			break;
		case "eventCallback": // Handle Callback
			var list = msg.data.listenerIds;
			var length = list.length;
			for(var i = 0; i < length; i++) {
				try {
					var t = listenerQueue[list[i]];
					if(!t) continue;
					t.callback(msg.data);
				}
				catch(e) {}
			}
			break;
		}
	}
}

window.addEventListener("message", function () {
	try {
		eventManager.apply(this, arguments);
	}
	catch(e) {}
}, false);
/*************************************
End HTML5 Event System - Do Not Modify
*************************************/

window.addEventListener("load", checkIfAdKitReady);